# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetServerlessLifecyclePolicyResult',
    'AwaitableGetServerlessLifecyclePolicyResult',
    'get_serverless_lifecycle_policy',
    'get_serverless_lifecycle_policy_output',
]

@pulumi.output_type
class GetServerlessLifecyclePolicyResult:
    """
    A collection of values returned by getServerlessLifecyclePolicy.
    """
    def __init__(__self__, created_date=None, description=None, id=None, last_modified_date=None, name=None, policy=None, policy_version=None, type=None):
        if created_date and not isinstance(created_date, str):
            raise TypeError("Expected argument 'created_date' to be a str")
        pulumi.set(__self__, "created_date", created_date)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_modified_date and not isinstance(last_modified_date, str):
            raise TypeError("Expected argument 'last_modified_date' to be a str")
        pulumi.set(__self__, "last_modified_date", last_modified_date)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if policy and not isinstance(policy, str):
            raise TypeError("Expected argument 'policy' to be a str")
        pulumi.set(__self__, "policy", policy)
        if policy_version and not isinstance(policy_version, str):
            raise TypeError("Expected argument 'policy_version' to be a str")
        pulumi.set(__self__, "policy_version", policy_version)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="createdDate")
    def created_date(self) -> str:
        """
        The date the lifecycle policy was created.
        """
        return pulumi.get(self, "created_date")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Description of the policy. Typically used to store information about the permissions defined in the policy.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastModifiedDate")
    def last_modified_date(self) -> str:
        """
        The date the lifecycle policy was last modified.
        """
        return pulumi.get(self, "last_modified_date")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def policy(self) -> str:
        """
        JSON policy document to use as the content for the new policy.
        """
        return pulumi.get(self, "policy")

    @property
    @pulumi.getter(name="policyVersion")
    def policy_version(self) -> str:
        """
        Version of the policy.
        """
        return pulumi.get(self, "policy_version")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")


class AwaitableGetServerlessLifecyclePolicyResult(GetServerlessLifecyclePolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetServerlessLifecyclePolicyResult(
            created_date=self.created_date,
            description=self.description,
            id=self.id,
            last_modified_date=self.last_modified_date,
            name=self.name,
            policy=self.policy,
            policy_version=self.policy_version,
            type=self.type)


def get_serverless_lifecycle_policy(name: Optional[str] = None,
                                    type: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetServerlessLifecyclePolicyResult:
    """
    Data source for managing an AWS OpenSearch Serverless Lifecycle Policy.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.opensearch.get_serverless_lifecycle_policy(name="example-lifecycle-policy",
        type="retention")
    ```


    :param str name: Name of the policy
    :param str type: Type of lifecycle policy. Must be `retention`.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws:opensearch/getServerlessLifecyclePolicy:getServerlessLifecyclePolicy', __args__, opts=opts, typ=GetServerlessLifecyclePolicyResult).value

    return AwaitableGetServerlessLifecyclePolicyResult(
        created_date=pulumi.get(__ret__, 'created_date'),
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        last_modified_date=pulumi.get(__ret__, 'last_modified_date'),
        name=pulumi.get(__ret__, 'name'),
        policy=pulumi.get(__ret__, 'policy'),
        policy_version=pulumi.get(__ret__, 'policy_version'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_serverless_lifecycle_policy)
def get_serverless_lifecycle_policy_output(name: Optional[pulumi.Input[str]] = None,
                                           type: Optional[pulumi.Input[str]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetServerlessLifecyclePolicyResult]:
    """
    Data source for managing an AWS OpenSearch Serverless Lifecycle Policy.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.opensearch.get_serverless_lifecycle_policy(name="example-lifecycle-policy",
        type="retention")
    ```


    :param str name: Name of the policy
    :param str type: Type of lifecycle policy. Must be `retention`.
    """
    ...
